----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:43:35 06/30/2014 
-- Design Name: 
-- Module Name:    DIVIDER - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DIVIDER is
    Generic(DIV : integer := 1);
    Port ( S : in  STD_LOGIC;
           Q : out  STD_LOGIC);
end DIVIDER;

architecture Behavioral of DIVIDER is
constant HDIV : integer := DIV/2;
signal cnt : std_logic_vector(15 downto 0) := x"0001";
signal iq : std_logic := '0';

begin
Q <= iq;

  process(s)
  begin
  if(s'event and s = '1') then
    if(cnt = HDIV) then
      iq <= not iq;
      cnt <= x"0001";
    else
      cnt <= cnt + '1';
    end if;
  end if;
  end process;

end Behavioral;

