----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:45:50 07/02/2014 
-- Design Name: 
-- Module Name:    GG - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity GG is
    Port ( clk : in  STD_LOGIC;
           s : in  STD_LOGIC;
           dly : in STD_LOGIC_VECTOR(15 downto 0);
           wid : in STD_LOGIC_VECTOR(15 downto 0);
           q : out  STD_LOGIC);
end GG;

architecture Behavioral of GG is
signal cnt : std_logic_vector(15 downto 0) := x"0000";

type GGSTATE is (IDLE,START,PON,STOP);
signal state : GGSTATE;

begin

  process(clk)
  begin
  if(clk'event and clk='1') then
    case state is 
    when IDLE =>
      if(s = '1') then
        state <= START;
        if(dly = x"0000") then
          q <= '1';
          cnt <= x"0002";
        else
          q <= '0';
          cnt <= x"0001";
        end if;
      else
        state <= IDLE;
        q <= '0';
        cnt <= x"0001";
      end if;
    when START =>
      if(cnt < dly) then
        q <= '0';
        state <= START;
        cnt <= cnt + '1';
      else
        if((dly = x"0000" and wid = x"0000") or (dly = x"0000" and wid = x"0001")) then
          q <= '0';
          state <= STOP;
        else
          q <= '1';
          state <= PON;
          if(dly = x"0000") then
            cnt <= x"0002";
          else
            cnt <= x"0001";
          end if;
        end if;
      end if;
    when PON =>
      if(cnt < wid) then
        q <= '1';
        state <= PON;
        cnt <= cnt + '1';
      else
        q <= '0';
        state <= STOP;
        cnt <= (others => '0');
      end if;
    when STOP =>
      if(s = '0') then
        state <= IDLE;
      else
        state <= STOP;
      end if;
      q <= '0';
      cnt <= x"0001";
    end case;
  end if;
  end process;
        
end Behavioral;

