----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:54:34 04/21/2012 
-- Design Name: 
-- Module Name:    GTOCOM - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;


entity GTOCOM is
    Port ( clk : in  STD_LOGIC;
           rxf : in  STD_LOGIC;
           rdata : in  STD_LOGIC_VECTOR (7 downto 0);
           txf : out  STD_LOGIC;
           addr : out  STD_LOGIC_VECTOR (7 downto 0);
           data : out  STD_LOGIC_VECTOR (7 downto 0));
end GTOCOM;

architecture Behavioral of GTOCOM is

signal iaddr, idata : std_logic_vector(7 downto 0) := x"00";
type CSTATE is (CADDR, CVALUE);
signal vstate, txstate : CSTATE := CADDR;
signal itxf : std_logic := '0';

begin

addr <= iaddr;
data <= idata;

  process(clk)
  begin
  if(clk'event and clk = '1') then
    if(itxf = '1' and txstate = CADDR) then
      txstate <= CVALUE;
      txf <= '1';
    elsif(itxf = '1' and txstate = CVALUE) then
      txstate <= CVALUE;
      txf <= '0';
    else -- itxf='0'
      txstate <= CADDR;
      txf <= '0';
    end if;
  end if;
  end process;

  process(rxf)
  begin
  if(rxf'event and rxf = '0') then
    if(vstate = CADDR) then
      iaddr <= rdata;
      idata <= idata;
      itxf <= '0';
      if(rdata(7 downto 6) = "11") then
        vstate <= CADDR;
      else
        vstate <= CVALUE;
      end if;
    else
      iaddr <= iaddr;
      idata <= rdata;
      itxf <= '1';
      vstate <= CADDR;
    end if;
  end if;
  end process;

end Behavioral;

