----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:24:04 06/30/2014 
-- Design Name: 
-- Module Name:    GTOVAL - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity GTOVAL is
    Generic (
      INIT : std_logic_vector(7 downto 0);
      ADDR : integer);
    Port ( s : in  STD_LOGIC;
           rst  : in  STD_LOGIC;
           vaddr : in  STD_LOGIC_VECTOR (5 downto 0);
           din  : in  STD_LOGIC_VECTOR (7 downto 0);
           dout : out  STD_LOGIC_VECTOR (7 downto 0));
end GTOVAL;

architecture Behavioral of GTOVAL is
signal val : std_logic_vector(7 downto 0) := INIT;
constant iaddr : std_logic_vector(5 downto 0) := conv_std_logic_vector(ADDR, 6);

begin
dout <= val;

  process(s, rst)
  begin
  if(rst = '1') then
    val <= INIT;
  elsif(s'event and s = '1') then
    if(vaddr = iaddr) then
      val <= din;
    else
      val <= val;
    end if;
  end if;
  end process;

end Behavioral;

