----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:08:05 02/22/2011 
-- Design Name: 
-- Module Name:    RS232RX - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity RS232RX is
    Generic(
      MARGIN : integer := 20;
      SKIP   : integer := 52);
    Port ( clk : in  STD_LOGIC;
           rx : in  STD_LOGIC;
           rxe : in  STD_LOGIC;
           rxf : out  STD_LOGIC;
           data : out  STD_LOGIC_VECTOR (7 downto 0));
end RS232RX;

architecture Behavioral of RS232RX is

signal icnt : std_logic_vector(7 downto 0) := x"01";
signal ibit : std_logic_vector(7 downto 0) := "00000000";
signal bcnt : std_logic_vector(3 downto 0) := "0000";
signal istart, irxf : std_logic := '0';

begin

data <= ibit;
rxf <= irxf;

  process(clk)
  begin
    if(clk'event and clk = '1') then
      if(rxe = '1') then
        if(istart = '0') then
          if(rx = '0') then
            bcnt <= "0000";
            if(icnt = MARGIN) then
              istart <= '1';
              icnt <= x"01";
            else
              istart <= '0';
              icnt <= icnt + '1';
            end if;
          else -- rx = '1' noop
            bcnt <= "0000";
            istart <= '0';
            icnt <= x"01";
          end if;
          ibit <= ibit;
          irxf <= '0';
        else  -- istart = '1'
          istart <= '1';
          if(icnt < SKIP) then
            icnt <= icnt + '1';
            bcnt <= bcnt;
            irxf <= irxf;
          else -- icnt >= SKIP
            icnt <= x"01";
            bcnt <= bcnt + '1';
            case bcnt is
              when "0000" => ibit(0) <= rx; ibit(7 downto 1) <= ibit(7 downto 1); irxf <= '0'; istart <= '1';
              when "0001" => ibit(1) <= rx; ibit(7 downto 2) <= ibit(7 downto 2); ibit(0) <= ibit(0); irxf <= '0'; istart <= '1';
              when "0010" => ibit(2) <= rx; ibit(7 downto 3) <= ibit(7 downto 3); ibit(1 downto 0) <= ibit(1 downto 0); irxf <= '0'; istart <= '1';
              when "0011" => ibit(3) <= rx; ibit(7 downto 4) <= ibit(7 downto 4); ibit(2 downto 0) <= ibit(2 downto 0); irxf <= '0'; istart <= '1';
              when "0100" => ibit(4) <= rx; ibit(7 downto 5) <= ibit(7 downto 5); ibit(3 downto 0) <= ibit(3 downto 0); irxf <= '0'; istart <= '1';
              when "0101" => ibit(5) <= rx; ibit(7 downto 6) <= ibit(7 downto 6); ibit(4 downto 0) <= ibit(4 downto 0); irxf <= '0'; istart <= '1';
              when "0110" => ibit(6) <= rx; ibit(7) <= ibit(7); ibit(5 downto 0) <= ibit(5 downto 0); irxf <= '0'; istart <= '1';
              when "0111" => ibit(7) <= rx; ibit(6 downto 0) <= ibit(6 downto 0); irxf <= '1'; istart <= '1';
              when "1000" => ibit <= ibit; irxf <= '0'; istart <= '0';
              when others => ibit <= ibit; irxf <= '0'; istart <= '0';
            end case;
          end if;
        end if;
      else -- rxe = '0' noop
        icnt <= x"01";
        bcnt <= "0000";
        irxf <= '0';
        ibit <= x"00";
      end if;
    end if;
  end process;
  

end Behavioral;

