----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:14:30 02/23/2011 
-- Design Name: 
-- Module Name:    RS232TX - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity RS232TX is
    Generic(
      SKIP : integer := 52);
    Port ( clk : in  STD_LOGIC;
           tx : out STD_LOGIC;
           txe : out  STD_LOGIC;
           txf : in  STD_LOGIC;
           data : in  STD_LOGIC_VECTOR (7 downto 0));
end RS232TX;

architecture Behavioral of RS232TX is
signal icnt : std_logic_vector(7 downto 0) := x"01";
signal bcnt : std_logic_vector(3 downto 0) := "0000";
signal istart : std_logic := '0';
signal itx : std_logic;

begin
tx <= itx;

  process(clk)
  begin
    if(clk'event and clk='1') then
      if(istart = '0') then
        icnt <= x"01";
        bcnt <= "0000";
        itx <= '1';
        if(txf = '1') then
          istart <= '1';
          txe <= '0';
        else
          istart <= '0';
          txe <= '1';
        end if;
      else -- istart = '1'
        if(icnt < SKIP) then
          icnt <= icnt + '1';
          bcnt <= bcnt;
        else -- icnt >= SKIP
          icnt <= x"01";
          bcnt <= bcnt + '1';
        end if;
          
        case bcnt is
          when "0000" => itx <= '0'; istart <= '1'; txe <= '0';  -- start bit
          when "0001" => itx <= data(0); istart <= '1'; txe <= '0';
          when "0010" => itx <= data(1); istart <= '1'; txe <= '0';
          when "0011" => itx <= data(2); istart <= '1'; txe <= '0';
          when "0100" => itx <= data(3); istart <= '1'; txe <= '0';
          when "0101" => itx <= data(4); istart <= '1'; txe <= '0';
          when "0110" => itx <= data(5); istart <= '1'; txe <= '0';
          when "0111" => itx <= data(6); istart <= '1'; txe <= '0';
          when "1000" => itx <= data(7); istart <= '1'; txe <= '0';
          when "1001" => itx <= '1'; istart <= '1'; txe <= '0';  -- stop bit
          when others => itx <= '1'; istart <= '0'; txe <= '1';
        end case;
      end if;
    end if;
  end process;

end Behavioral;

