----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:02:40 06/30/2014 
-- Design Name: 
-- Module Name:    SkelGTO - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.NUMERIC_STD.ALL;

library UNISIM;
use UNISIM.VComponents.all;

use WORK.GTOPackage.ALL;

entity SkelGTO is
    Port ( CLOCK : in  STD_LOGIC;
           LED  : out  STD_LOGIC_VECTOR(7 downto 0);
           NIN  : in STD_LOGIC_VECTOR(23 downto 0);           
           NOUT : out STD_LOGIC_VECTOR(7 downto 0);
           ECS  : out STD_LOGIC;
           EDI  : in  STD_LOGIC;
           EDO  : out STD_LOGIC;
           ECK  : out STD_LOGIC;
           XRX  : in  STD_LOGIC;
           XTX  : out  STD_LOGIC);
end SkelGTO;

architecture Behavioral of SkelGTO is

COMPONENT GTOCORE
    Generic ( INITVAL : gtovalarray);
    Port ( CLOCK : in  STD_LOGIC;
           XRX : in  STD_LOGIC;
           XTX : out  STD_LOGIC;
           ECS : out  STD_LOGIC;
           EDI : in  STD_LOGIC;
           EDO : out  STD_LOGIC;
           ECK : out  STD_LOGIC;
           rst : out  STD_LOGIC;
           active : out  STD_LOGIC;
           ucomf : out STD_LOGIC;
           utxf : in STD_LOGIC;
           uaddr : out  STD_LOGIC_VECTOR (5 downto 0);
           urxdata : out  STD_LOGIC_VECTOR (7 downto 0);
           val     : out gtovalarray;
           userval : in gtovalarray);
end COMPONENT;

---------- Do not edit -----------
signal rst, active, utxf, ucomf : std_logic := '0';
signal urxdata : std_logic_vector(7 downto 0);
signal uaddr : std_logic_vector(5 downto 0);
signal val : gtovalarray;
attribute S: string;
attribute keep : string;
attribute S of val : signal is "TRUE";
attribute keep of val : signal is "TRUE";
----------------------------------

--------- Initiali value ---------
constant initval : gtovalarray := (
  x"53", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00", 
  x"00", x"00", x"00", x"00", x"00", x"00", x"00", x"00");

signal userval : gtovalarray := (
  x"01", x"00", x"00", x"00", x"00", x"00", x"00", x"07", 
  x"08", x"00", x"00", x"00", x"00", x"00", x"00", x"07", 
  x"10", x"00", x"00", x"00", x"00", x"00", x"00", x"1f", 
  x"08", x"00", x"00", x"00", x"00", x"00", x"00", x"0f", 
  x"20", x"00", x"00", x"00", x"00", x"00", x"00", x"27", 
  x"28", x"00", x"00", x"00", x"00", x"00", x"00", x"2f", 
  x"30", x"00", x"00", x"00", x"00", x"00", x"00", x"37", 
  x"38", x"00", x"00", x"00", x"00", x"00", x"00", x"3f");

-----------------------------------


----- to use example module ------
--- clock signal will be 1/DIV ---
--- DIV value is 0 to 65535    ---
--- DIV = 0 is 1/65536         ---
	COMPONENT DIVIDER
  GENERIC (DIV : integer);
	PORT(
		S : IN std_logic;          
		Q : OUT std_logic
		);
	END COMPONENT;
  
 	COMPONENT GG
	PORT(
		clk : IN std_logic;
		s : IN std_logic;
		dly : IN std_logic_vector(15 downto 0);
		wid : IN std_logic_vector(15 downto 0);          
		q : OUT std_logic
		);
	END COMPONENT;

---------- Example signals -------
signal ledbuff : std_logic_vector(7 downto 0);
signal pulsewidth : std_logic_vector(15 downto 0);
signal pulse, pulsetrg, nimand, nimor, clk1k : std_logic;
----------------------------------


-----------------------------------

begin

---------- Do not edit ------------
  GTOCoreInst : GTOCORE
  Generic Map(
    INITVAL => initval)
  Port Map(
    CLOCK => CLOCK,
    XRX => XRX,
    XTX => XTX,
    ECS => ECS,
    EDI => EDI,
    EDO => EDO,
    ECK => ECK,
    rst => rst,
    active => active,
    ucomf => ucomf,
    utxf => utxf,
    uaddr => uaddr,
    urxdata => urxdata,
    val => val,
    userval => userval);
-----------------------------------
    
-- generate 1kHz clock from 50MHz internal clock by the example module
  DividerInst : DIVIDER
  Generic Map(
    DIV => 50000)
  Port Map(
    S => CLOCK,
    Q => clk1k
  );

-- generate NIM pulse, width is given by val
	GGInst: GG PORT MAP(
		clk => CLOCK,
		s => pulsetrg,
		dly => x"0000",
		wid => pulsewidth,
		q => pulse
	);
pulsewidth <= val(1) & val(0);

  
-- AND of NIM input 0 to 3
nimand <= NIN(0) and NIN(1) and NIN(2) and NIN(3);

-- OR of NIM input 4 to 15
nimor  <= NIN(4) or NIN(5) or NIN(6) or NIN(7)
       or NIN(8) or NIN(9) or NIN(10) or NIN(11)
       or NIN(12) or NIN(13) or NIN(14) or NIN(15);

NOUT(0) <= nimand;
NOUT(1) <= nimor;
NOUT(2) <= clk1k;
NOUT(3) <= active;
NOUT(6 downto 4) <= "111";
NOUT(7) <= pulse;

utxf <= ucomf when uaddr = "000001" else '0';
pulsetrg <= ucomf when uaddr = "000000" else '0';

-- LED(0 to 6) is or of val(0)(0 to 6) and NIM input(16 to 22)
ledbuff(6 downto 0) <= val(0)(6 downto 0) or NIN(22 downto 16);

-- LED(7) is or of active and NIM input(23), active is network command activity
ledbuff(7) <= active or NIN(23);

-- Since LED port is on when value is '0', ledbuff is inverted
LED <= not ledbuff;

-- copy data to userval
  process(ucomf)
  begin
  if(ucomf'event and ucomf = '1') then
    if(uaddr = "000010") then
      userval(0) <= urxdata;
    end if;
  end if;
  end process;

end Behavioral;

